<?php
/**
 * Plugin Name: Dadevarzan WordPress personnel plugin
 * Plugin URI: https://wordpress.org/plugins/dadevarzan-wp-personnel
 * GitHub Plugin URI: https://github.com/dadevarzan/dadevarzan-wp-personnel
 * Description: personnel post type for wordpress
 * Version: 1.2.3
 * Author: Dadevarzan Team
 * Author URI: http://www.dadevarzan.com
 * Text Domain: dadevarzan-wp-personnel
 * Domain Path: /languages
*/

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
    die;
}

if ( !class_exists( 'dadevarzanWpPersonnel' ) ) {

    class dadevarzanWpPersonnel
    {

        public static function initialize()
        {

            add_action( 'plugins_loaded', 'dadevarzanWpPersonnel::load_text_domain' );
            add_action( 'init', 'dadevarzanWpPersonnel::add_post_type' );
            add_action( 'init', 'dadevarzanWpPersonnel::add_fields' );
            add_action('init', 'dadevarzanWpPersonnel::add_taxonomy');
            add_action('init', 'dadevarzanWpPersonnel::add_role_caps');
            add_action( 'plugins_loaded', 'dadevarzanWpPersonnel::load_templates' );

        }

        public static function add_post_type()
        {

            $labels = array(
                "name" => __('Personnel', 'dadevarzan-wp-personnel'),
                "singular_name" =>  __('Personnel', 'dadevarzan-wp-personnel'),
                "menu_name" =>  __('Personnel', 'dadevarzan-wp-personnel'),
                "all_items" =>  __('All Personnel', 'dadevarzan-wp-personnel'),
                "add_new" => __('Add Personnel', 'dadevarzan-wp-personnel'),
                "add_new_item" => __('Add New Personnel', 'dadevarzan-wp-personnel'),
            );

            $args = array(
                "label" => __('Personnel', 'dadevarzan-wp-personnel'),
                "labels" => $labels,
                "description" => "",
                "public" => true,
                "publicly_queryable" => true,
                "show_ui" => true,
                "show_in_rest" => true,
                "rest_base" => "",
				"show_in_nav_menus" => true,
                "has_archive" => true,
                "show_in_menu" => true,
                "exclude_from_search" => false,
                "hierarchical" => false,
                "rewrite" => array( "slug" => "personnel", "with_front" => true ),
                "query_var" => true,
                "menu_icon" => "dashicons-admin-users",
                "supports" => array( "title", "excerpt", "editor", "thumbnail", "comments", "author" ),
                "capability_type" => array('personnel', 'personnels'),
                "map_meta_cap" => true,
                "taxonomies" => array( "personnel_category" ),
            );

            register_post_type( "personnel", $args );

        }

        public static function add_fields()
        {

            if( function_exists('acf_add_local_field_group') ):

                acf_add_local_field_group(array(
                    'key' => 'group_59e59c96eb065',
                    'title' => __('Personnel', 'dadevarzan-wp-personnel'),
                    'fields' => array(
                        array(
                            'key' => 'field_59e59cb7b8169',
                            'label' => __('Job Title', 'dadevarzan-wp-personnel'),
                            'name' => 'person_job_title',
                            'type' => 'text',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'placeholder' => '',
                            'prepend' => '',
                            'append' => '',
                            'maxlength' => '',
                        ),
						array(
							'key' => 'field_5e95b226edb24',
							'label' => __('Phone', 'dadevarzan-wp-personnel'),
							'name' => 'person_phone',
							'type' => 'text',
							'instructions' => '',
							'required' => 0,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'default_value' => '',
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'maxlength' => '',
						),
						array(
							'key' => 'field_5e95b23dedb25',
							'label' => __('Fax', 'dadevarzan-wp-personnel'),
							'name' => 'person_fax',
							'type' => 'text',
							'instructions' => '',
							'required' => 0,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'default_value' => '',
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'maxlength' => '',
						),
						array(
							'key' => 'field_5e95b24aedb26',
							'label' => __('Email', 'dadevarzan-wp-personnel'),
							'name' => 'person_email',
							'type' => 'text',
							'instructions' => '',
							'required' => 0,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'default_value' => '',
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'maxlength' => '',
						),						
                        array(
                            'key' => 'field_59e59d11b816a',
                            'label' => __('Education', 'dadevarzan-wp-personnel'),
                            'name' => 'person_education',
                            'type' => 'text',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'placeholder' => '',
                            'prepend' => '',
                            'append' => '',
                            'maxlength' => '',
                        ),
                        array(
                            'key' => 'field_59e5a804b816c',
                            'label' => __('Facebook Address', 'dadevarzan-wp-personnel'),
                            'name' => 'person_facebook_address',
                            'type' => 'url',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'placeholder' => '',
                        ),
                        array(
                            'key' => 'field_59e5a83db816d',
                            'label' => __('Linkedin Address', 'dadevarzan-wp-personnel'),
                            'name' => 'person_linkedin_address',
                            'type' => 'url',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'placeholder' => '',
                        ),
                        array(
                            'key' => 'field_59e5a860b816e',
                            'label' => __('Twitter Address', 'dadevarzan-wp-personnel'),
                            'name' => 'person_twitter_address',
                            'type' => 'url',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'placeholder' => '',
                        ),
                        array(
                            'key' => 'field_59e5a8aeb816f',
                            'label' => __('Google Plus Address', 'dadevarzan-wp-personnel'),
                            'name' => 'person_google_plus_address',
                            'type' => 'url',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'placeholder' => '',
                        ),
                    ),
                    'location' => array(
                        array(
                            array(
                                'param' => 'post_type',
                                'operator' => '==',
                                'value' => 'personnel',
                            ),
                        ),
                    ),
                    'menu_order' => 0,
                    'position' => 'acf_after_title',
                    'style' => 'default',
                    'label_placement' => 'top',
                    'instruction_placement' => 'label',
                    'hide_on_screen' => '',
                    'active' => 1,
                    'description' => '',
                ));

            endif;

        }

        public static function add_taxonomy()
        {

            $labels = array(
                "name" => __('Personnel Categories', 'dadevarzan-wp-personnel'),
                "singular_name" => __('Personnel Category', 'dadevarzan-wp-personnel'),
            );

            $args = array(
                "label" => __('Personnel Categories', 'dadevarzan-wp-personnel'),
                "labels" => $labels,
                "public" => true,
                "hierarchical" => true,
                "show_ui" => true,
                "show_in_menu" => true,
                "show_in_nav_menus" => true,
                "query_var" => true,
                "rewrite" => array( 'slug' => 'personnel_category', 'with_front' => true, ),
                "show_admin_column" => true,
                "show_in_rest" => true,
                "rest_base" => "",
                "show_in_quick_edit" => true,
                'capabilities' => array(
                    'manage_terms' => 'manage_categories',
                    'edit_terms' => 'manage_categories',
                    'delete_terms' => 'manage_categories',
                    'assign_term' => 'manage_categories',
                    'assign_terms' => 'manage_categories',
                ),
            );

            register_taxonomy( 'personnel_category', array( 'personnel' ), $args );

        }

        public static function add_role_caps()
        {

            // Add the roles you'd like to administer the custom post types
            $roles = array('wpseo_editor', 'wpseo_manager', 'shop_manager', 'editor', 'administrator');

            // Loop through each role and assign capabilities
            foreach($roles as $the_role) {

                $role = get_role($the_role);

                if ( empty($role) ) {
                    continue;
                }

                $role->add_cap( 'read' );
                $role->add_cap( 'read_personnel' );
                $role->add_cap( 'edit_personnel' );
                $role->add_cap( 'edit_personnels' );
                $role->add_cap( 'edit_private_personnels' );
                $role->add_cap( 'edit_published_personnels' );
                $role->add_cap( 'edit_others_personnels' );
                $role->add_cap( 'delete_personnel' );
                $role->add_cap( 'delete_personnels' );
                $role->add_cap( 'delete_private_personnels' );
                $role->add_cap( 'delete_published_personnels' );
                $role->add_cap( 'delete_others_personnels' );
                $role->add_cap( 'publish_personnels' );
                $role->add_cap( 'read_private_personnels' );

            }

        }

        public static function load_templates() {

            /**
             * Return if the builder isn't installed or if the current
             * version doesn't support registering templates.
             */
            if ( ! class_exists( 'FLBuilder' ) || ! method_exists( 'FLBuilder', 'register_templates' ) ) {
                return;
            }

            $layoutTemplatePath = plugin_dir_path( __FILE__ ) . 'data/templates.dat';
            if ( file_exists( $layoutTemplatePath ) && class_exists( 'FLThemeBuilder' ) ) {
                FLBuilder::register_templates( $layoutTemplatePath, array('group' => 'personnel'));
            }

        }

        public static function load_text_domain()
        {
            load_plugin_textdomain( 'dadevarzan-wp-personnel' , FALSE, basename( dirname( __FILE__ ) ) . '/languages'  );
        }

    }

    dadevarzanWpPersonnel::initialize();

}
